import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnInit, Renderer2 } from '@angular/core';
import { ControlContainer, ControlValueAccessor } from '@angular/forms';
import { NgConfigService } from '../../config/ng-config.service';
import { ControlBase } from '../../shared/base/control-base.template';
import { IMaskServiceReturn, INgIMaskConfig, NgMaskService } from '@douglas-serena/ng-masks';
export declare class NgAutocompleteComponent extends ControlBase implements OnInit, AfterViewInit, ControlValueAccessor {
    private renderer2;
    private ngMaskService;
    private ngConfig;
    private changeDetectorRef;
    loading: boolean;
    keyLabel: string;
    keyValue: string;
    showIsEmpty: boolean;
    secondaryControlName: string;
    secondaryKeyValueControl: string;
    positionMenu: 'auto' | 'above' | 'below';
    service: any;
    methodService: string;
    debounceTimeEventInput: number;
    set options(value: any[]);
    _options: {
        _label: string;
        _value: any;
        _root: any;
    }[];
    mask: INgIMaskConfig | string;
    _maskRef: IMaskServiceReturn;
    constructor(renderer2: Renderer2, ngMaskService: NgMaskService, ngConfig: NgConfigService, controlContainer: ControlContainer, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    handleSaveValue(value?: HTMLElement | string | number, unmask?: boolean): void;
    debounceTimeInput: any;
    inputDebounce: EventEmitter<any>;
    handleInputDebounce(value?: any): void;
    handleSearch(value: string): Promise<void>;
    selected: EventEmitter<any>;
    selectedEmpty: EventEmitter<any>;
    handleSelect(option?: any): void;
    handleEmpty(valueElement?: string): void;
    handleBlur(event: FocusEvent, index?: number): void;
    handleFocus(event: FocusEvent): void;
    handleInput(event: KeyboardEvent): void;
    writeValue: (value: number | string) => void;
}
