import { ElementRef, EventEmitter, Renderer2 } from '@angular/core';
import { ControlContainer, ControlValueAccessor, FormControl, FormControlDirective } from '@angular/forms';
import { NgConfigService } from '../../config/ng-config.service';
import { TypeFields } from '../../interfaces/config/ng-config.interface';
import { INgIconConfig, NgIconPositionsConfig } from '../../interfaces/config/ng-icon-config.interface';
import { NgControlBase } from './control-base.interface';
export declare class ControlBase implements ControlValueAccessor, NgControlBase {
    private _controlContainer;
    private _renderer2;
    private _ngConfig;
    formControlDirective: FormControlDirective;
    rootRef: ElementRef<HTMLInputElement>;
    formControl: FormControl;
    formControlName: string;
    id: string;
    label: string;
    type: string;
    prefix: string;
    suffix: string;
    readonly: boolean;
    disabled: boolean;
    required: boolean | null;
    labelFixed: boolean;
    set placeholder(text: string | null);
    _placeholder?: string | null;
    help: string;
    color: string;
    icon: NgIconPositionsConfig;
    size: 'lg' | 'md' | 'sm';
    theme: 'outline' | 'fill' | 'standard' | 'legacy';
    errors: {
        [key: string]: string;
    };
    get control(): FormControl;
    constructor(_controlContainer: ControlContainer, _renderer2: Renderer2, _ngConfig: NgConfigService);
    superOnInit(typeField: TypeFields): void;
    superAfterViewInit(): void;
    handleClickIcon(prop: {
        event: Event;
        icon: INgIconConfig | undefined;
    }, input: any, position: 'left' | 'right' | 'loading'): void;
    blur: EventEmitter<any>;
    handleBlur(event: FocusEvent): void;
    focus: EventEmitter<any>;
    handleFocus(event: FocusEvent): void;
    handleChange: (_: any) => void;
    handleTouched: () => void;
    registerOnTouched: (fn: () => void) => () => void;
    setDisabledState: (isDisabled: boolean) => boolean;
    registerOnChange: (fn: (_: any) => void) => (_: any) => void;
    writeValue: (value: number | string) => void;
}
